


#variable started 0

if {![info exists started]} {variable started 0}

if {$started != 0} {

     variable JS ""
     variable LogFlag

     if {$LogFlag == 1} {InsertLog "Last Updated: [clock format [clock seconds] -format "%B %d, %Y %H:%M:%S"]"}

    do_click
}

if {$started == 0} {           ;#  first time load code and define local variables
    set started 1

   package require htmlparse

    variable LogText ""
    variable LogFlag 0
    variable LogCount 0
    variable DebugFlag 0

    variable ShowLogFlag 0

    variable JS ""

    variable MaxDrives 4
    variable TapeServerState 0
    variable Storage 0
    variable InUse
    variable StreamInfo {}
    variable DeviceInfo {}
    variable AcqInfo {}

    for {set i 0} {$i < $MaxDrives} {incr i} {
      set InUse([set i]PAT) 0
    }

    variable ErrorStatus
    set ErrorStatus(0)    "No Error"
    set ErrorStatus(1)    "Device already in use"
    set ErrorStatus(8)    "Invalid Access Token"
    set ErrorStatus(14)   "Client ID already in use"
    set ErrorStatus(6)    "Device already allocated"
    set ErrorStatus(7)    "Device not in correct state for action"
    set ErrorStatus(3)    "Cannot issue more Access Tokens"
    set ErrorStatus(13)   "Server not in correct state for action"
    set ErrorStatus(11)   "Invalid/Unknown Client ID"
    set ErrorStatus(15)   "Invalid/Unknown Device"


    variable DeviceStatus {unallocated allocated mounting mounted opening open closing executing initialising \
    identifying putting moving twelve thirteen fourteen fifteen "device error"}

    variable Properties
    set Properties(DEVICES) ""
    set Properties(ALLOCATE) ""
    set Properties(DEALLOCATE) ""
    set Properties(INITIALISE) ""
    set Properties(IDENTIFY) ""
    set Properties(MOUNT) ""
    set Properties(DISMOUNT) ""
    set Properties(VOLN) ""
    set Properties(FILEN) ""
    set Properties(OPEN) ""
    set Properties(CLOSE) ""
    set Properties(RUN) ""
 

    variable TapeDeviceList "NULL"

    variable ID "0PAT"
    variable DevName "NULL"
    variable VolN "NULL"
    variable FileN "NULL"
    variable DevStatus "Unknown"
    variable StreamState {0 0 0 0}

    variable BlocksWritten 0
    variable KbytesWritten 0
    variable DataRate 0
    variable DataPercent 0

       variable label  0
       variable density  0
       variable OldVolN "NULL"

       variable access 2
       variable label 2
       variable reclen 0
       variable blklen 0

    variable RunName "R"
    variable RunNum 1

    proc show_variables {} {
        variable LogFlag
        variable LogCount
        variable ShowLogFlag
        variable ID
        variable InUse
        variable DevName
        variable DevStatus
        variable VolN
        variable FileN
        variable DeviceInfo
        variable StreamInfo
        variable AcqInfo
        variable RunName
        variable RunNum
        variable TapeDeviceList

         InsertLog "LogFlag=$LogFlag; LogCount=$LogCount; ShowLogFlag=$ShowLogFlag"
         InsertLog "DeviceList=$TapeDeviceList"
         InsertLog "ID=$ID InUse=$InUse($ID)"
         InsertLog "DevName=$DevName; DevStatus=$DevStatus; VolName=$VolN; FileName=$FileN"
         InsertLog "DeviceInfo=$DeviceInfo"
         InsertLog "StreamInfo=$StreamInfo"
         InsertLog "AcqInfo=$AcqInfo"
         InsertLog "RunName=$RunName; RunNum=$RunNum"
    }

   proc select_devicename {w} {
       variable ID
       variable DevName
       variable TapeDeviceList

       set DevName $w
       set ID "[lsearch $TapeDeviceList $DevName]PAT"
   }


   proc do_inquiredevices {} {
       variable DebugFlag
       global errorCode errorInfo
       variable ErrorStatus
       variable TapeDeviceList 
       variable DevName
       variable InUse

       set z [catch {::namespace inscope ::urn:TapeServer InquireAvailableDevices} msg]
# puts stdout "InquireAvailableDevices: $msg"
       set m [lindex $msg 5]
       if {$z == 0} {
           if {[first $m] == 0} {
                if {$DebugFlag} {InsertLog "InquireAvailableDevices returned: [tail $m]"}
                set TapeDeviceList {}
                set devices [tail $m]
                set id 0
                for {set i 0} {$i < [llength $devices]} {incr i 3} {
                    lappend TapeDeviceList "[lindex $devices [expr $i+1]]"
                    set InUse([set id]PAT) [lindex $devices $i]
                    incr id
                }
                if {$DevName == "NULL"} {set DevName [first $TapeDeviceList]}
           } else {
              if {[info exists ErrorStatus([first $m])]} \
                 {set msg $ErrorStatus([first $m])} else {set msg "Error [first $m]"}
              InsertLog "$msg\n InquireAvailableDevices returned:- \n[::htmlparse::mapEscapes $m]"
           } 
       } else {
           InsertLog "InquireAvailableDevices failed: Code= $errorCode; Info= [first [split $errorInfo \n]]"
       }
   }

   proc do_allocatedevice {} {
       variable DebugFlag
       variable ID
       variable DevName
       variable ErrorStatus
       global errorCode errorInfo

       set z [catch {::namespace inscope ::urn:TapeServer AllocateDevice $ID $DevName} msg]
# puts stdout "AllocateDevice $ID $DevName: $msg"
       set m [lindex $msg 5]
       if {$z == 0} {
           if {[first $m] == 0} {
              if {$DebugFlag} {InsertLog "AllocateDevice returned: [tail $m]"}
           } else {
              if {[info exists ErrorStatus([first $m])]} \
                 {set msg $ErrorStatus([first $m])} else {set msg "Error [first $m]"}
              InsertLog "$msg\n AllocateDevice returned:- \n[::htmlparse::mapEscapes $m]"
           } 
       } else {
           InsertLog "AllocateDevice failed: Code= $errorCode; Info= [first [split $errorInfo \n]]"
       }
   }

   proc do_deallocatedevice {} {
       variable DebugFlag
       variable ID
       variable ErrorStatus
       global errorCode errorInfo

       set z [catch {::namespace inscope ::urn:TapeServer DeallocateDevice $ID} msg]
# puts stdout "DeallocateDevice $ID: $msg"
       set m [lindex $msg 5]
       if {$z == 0} {
           if {[first $m] == 0} {
              if {$DebugFlag} {InsertLog "DeallocateDevice returned: [tail $m]"}
           } else {
             if {[info exists ErrorStatus([first $m])]} \
                 {set msg $ErrorStatus([first $m])} else {set msg "Error [first $m]"}
              InsertLog "$msg\n DeallocateDevice returned:- \n[::htmlparse::mapEscapes $m]"
           } 
       } else {
           InsertLog "DeallocateDevice failed: Code= $errorCode; Info= [first [split $errorInfo \n]]"
       }
   }

   proc do_inquiredevicestatus {} {
       variable DebugFlag
       variable ID
       variable DeviceInfo
       variable DevStatus
       variable ErrorStatus
       global errorCode errorInfo

       set z [catch {::namespace inscope ::urn:TapeServer InquireDeviceStatus $ID} msg]
# puts stdout "InquireDeviceStatus $ID: $msg"
       set m [lindex $msg 5]
       if {$z == 0} {
           if {[first $m] == 0} {
               if {$DebugFlag} {InsertLog "InquireDeviceStatus returned: [tail $m]"}
               set DeviceInfo [tail $m]
           } else {
              if {[first $m] != 15} {
                 if {[info exists ErrorStatus([first $m])]} \
                     {set msg $ErrorStatus([first $m])} else {set msg "Error [first $m]"}
                 InsertLog "$msg\n InquireDeviceStatus returned:- \n[::htmlparse::mapEscapes $m]"
              }
              set DeviceInfo {}
              set DevStatus "Unknown"
              set InUse($ID) 0
           } 
       } else {
           InsertLog "InquireDeviceStatus failed: Code= $errorCode; Info= [first [split $errorInfo \n]]"
           set DeviceInfo {}
           set DevStatus "Unknown"
           set InUse($ID) 0
       }
   }

   proc do_inquirestreamstatus {} {
       variable DebugFlag
       global errorCode errorInfo
       variable ID
       variable DeviceStatus
       variable ErrorStatus
       variable InUse
        variable DevName
        variable DevStatus
        variable VolN
        variable FileN
        variable StreamInfo

       set z [catch {::namespace inscope ::urn:TapeServer InquireStreamStatus $ID} msg]
# puts stdout "InquireStreamStatus $ID: $msg"
       set m [lindex $msg 5]
       if {$z == 0} {
           if {[first $m] == 0} {
               if {$DebugFlag} {InsertLog "InquireStreamStatus returned: [tail $m]"}
                  set StreamInfo [tail $m]
                  set state [lindex $StreamInfo 1]
                  set DevStatus [lindex $DeviceStatus $state]
                  set InUse($ID) 1
                  set DevName [lindex $StreamInfo 4]
                  if {$DevStatus == "mounted" || $DevStatus == "open"} {
                      set VolN [lindex $StreamInfo 5]
                      if {$VolN == 0} {set VolN ""}
                  }
                  if {$DevStatus == "open"} {
                      set FileN [lindex $StreamInfo 6]
                      if {$FileN == 0} {set FileN ""}
                  }
           } else {
              if {[first $m] != 15} {
                 if {[info exists ErrorStatus([first $m])]} \
                     {set msg $ErrorStatus([first $m])} else {set msg "Error [first $m]"}
                 InsertLog "$msg\n InquireStreamStatus returned:- \n[::htmlparse::mapEscapes $m]"
              }
              set InUse($ID) 0
              set StreamInfo {}
              set DevStatus "Unknown"
           } 
       } else {
           InsertLog "InquireStreamStatus failed: Code= $errorCode; Info= [first [split $errorInfo \n]]"
           set InUse($ID) 0
           set StreamInfo {}
           set DevStatus "Unknown"
       }
   }

   proc do_inquirestreamstate {s} {
       variable DebugFlag
       variable ID
       variable StreamState
       variable ErrorStatus
       global errorCode errorInfo

       set z [catch {::namespace inscope ::urn:TapeServer InquireStreamState $s} msg]
# puts stdout "InquireStreamState $s: $msg"
       set m [lindex $msg 5]
       if {$z == 0} {
           if {[first $m] == 0} {
               if {$DebugFlag} {InsertLog "InquireStreamState returned: [tail $m]"}
               set StreamState [tail $m]
               if {[llength $StreamState] == 1} {set StreamState [list 0 0 0 0]}
           } else {
             if {[info exists ErrorStatus([first $m])]} \
                 {set msg $ErrorStatus([first $m])} else {set msg "Error [first $m]"}
              InsertLog "$msg\n InquireStreamState returned:- \n[::htmlparse::mapEscapes $m]"
           } 
       } else {
           InsertLog "InquireStreamState failed: Code= $errorCode; Info= [first [split $errorInfo \n]]"
       }
   }

   proc do_claim {} {
       variable DebugFlag
       global errorCode errorInfo
       variable ErrorStatus

       set z [catch {::namespace inscope ::urn:TapeServer ClaimTapeServer} msg]
# puts stdout "ClaimTapeServer: $msg"
       set m [lindex $msg 5]
       if {$z == 0} {
           if {[first $m] == 0} {
              if {$DebugFlag} {InsertLog "ClaimTapeServer returned: [tail $m]"}
           } else {
             if {[info exists ErrorStatus([first $m])]} \
                 {set msg $ErrorStatus([first $m])} else {set msg "Error [first $m]"}
              InsertLog "$msg\n ClaimTapeServer returned:- \n[::htmlparse::mapEscapes $m]"
           } 
       } else {
           InsertLog "ClaimTapeServer failed: Code= $errorCode; Info= [first [split $errorInfo \n]]"
       }
   }

   proc do_free {} {
       variable DebugFlag
       global errorCode errorInfo
       variable ErrorStatus

       set z [catch {::namespace inscope ::urn:TapeServer FreeTapeServer} msg]
# puts stdout "FreeTapeServer: $msg"
       set m [lindex $msg 5]
       if {$z == 0} {
           if {[first $m] == 0} {
              if {$DebugFlag} {InsertLog "FreeTapeServer returned: [tail $m]"}
           } else {
             if {[info exists ErrorStatus([first $m])]} \
                 {set msg $ErrorStatus([first $m])} else {set msg "Error [first $m]"}
              InsertLog "$msg\n FreeTapeServer returned:- \n[::htmlparse::mapEscapes $m]"
           } 
       } else {
           InsertLog "FreeTapeServer failed: Code= $errorCode; Info= [first [split $errorInfo \n]]"
       }
   }

   proc do_identifyvolume {} {
       variable DebugFlag
       global errorCode errorInfo
       variable ID

       set z [catch {::namespace inscope ::urn:TapeServer IdentifyVolume $ID} msg]
# puts stdout "IdentifyVolume $ID: $msg"
       set m [lindex $msg 5]
       if {$z == 0} {
           if {[first $m] == 0} {
              if {$DebugFlag} {InsertLog "IdentifyVolume returned: [tail $m]"}
           } else {
             if {[info exists ErrorStatus([first $m])]} \
                 {set msg $ErrorStatus([first $m])} else {set msg "Error [first $m]"}
              InsertLog "$msg\n IdentifyVolume returned:- \n[::htmlparse::mapEscapes $m]"
           } 
       } else {
           InsertLog "IdentifyVolume failed: Code= $errorCode; Info= [first [split $errorInfo \n]]"
       }
   }

   proc do_initialisevolume {} {
       variable DebugFlag
       global errorCode errorInfo
       variable ID
       variable VolN
       variable label
       variable density
       variable OldVolN

       set z [catch {::namespace inscope ::urn:TapeServer InitialiseVolume $ID $VolN $label $density $OldVolN} msg]
# puts stdout "InitialiseVolume $ID $VolN $label $density $OldVolN: $msg"
       set m [lindex $msg 5]
       if {$z == 0} {
           if {[first $m] == 0} {
              if {$DebugFlag} {InsertLog "InitialiseVolume returned: [tail $m]"}
           } else {
             if {[info exists ErrorStatus([first $m])]} \
                 {set msg $ErrorStatus([first $m])} else {set msg "Error [first $m]"}
              InsertLog "$msg\n InitialiseVolume returned:- \n[::htmlparse::mapEscapes $m]"
           } 
       } else {
           InsertLog "InitialiseVolume failed: Code= $errorCode; Info= [first [split $errorInfo \n]]"
       }
   }

   proc do_mountvolume {} {
       variable DebugFlag
       global errorCode errorInfo
       variable ID
       variable VolN
       variable ErrorStatus

       set z [catch {::namespace inscope ::urn:TapeServer MountVolume $ID $VolN} msg]
# puts stdout "MountVolume $ID $VolN: $msg"
       set m [lindex $msg 5]
       if {$z == 0} {
           if {[first $m] == 0} {
              if {$DebugFlag} {InsertLog "MountVolume returned: [tail $m]"}
           } else {
             if {[info exists ErrorStatus([first $m])]} \
                 {set msg $ErrorStatus([first $m])} else {set msg "Error [first $m]"}
              InsertLog "$msg\n MountVolume returned:- \n[::htmlparse::mapEscapes $m]"
           } 
       } else {
           InsertLog "MountVolume failed: Code= $errorCode; Info= [first [split $errorInfo \n]]"
       }
   }

   proc do_dismountvolume {} {
       variable DebugFlag
       global errorCode errorInfo
       variable ID
       variable ErrorStatus

       set z [catch {::namespace inscope ::urn:TapeServer DismountVolume $ID} msg]
# puts stdout "DismountVolume $ID: $msg"
       set m [lindex $msg 5]
       if {$z == 0} {
           if {[first $m] == 0} {
              if {$DebugFlag} {InsertLog "DismountVolume returned: [tail $m]"}
           } else {
             if {[info exists ErrorStatus([first $m])]} \
                 {set msg $ErrorStatus([first $m])} else {set msg "Error [first $m]"}
              InsertLog "$msg\n DismountVolume returned:- \n[::htmlparse::mapEscapes $m]"
           } 
       } else {
           InsertLog "DismountVolume failed: Code= $errorCode; Info= [first [split $errorInfo \n]]"
       }
   }

   proc do_openfile {} {
       variable DebugFlag
       global errorCode errorInfo
       variable ErrorStatus
       variable ID
       variable FileN
        variable RunName
        variable RunNum
       variable access
       variable label
       variable reclen
       variable blklen

       set FileN [set RunName][set RunNum]

       set z [catch {::namespace inscope ::urn:TapeServer OpenFile $ID $access $label $reclen $blklen $FileN} msg]
# puts stdout "OpenFile $ID $access $label $reclen $blklen $FileN: $msg"
       set m [lindex $msg 5]
       if {$z == 0} {
           if {[first $m] == 0} {
              if {$DebugFlag} {InsertLog "OpenFile returned: [tail $m]"}
           } else {
             if {[info exists ErrorStatus([first $m])]} \
                 {set msg $ErrorStatus([first $m])} else {set msg "Error [first $m]"}
              InsertLog "$msg\n OpenFile returned:- \n[::htmlparse::mapEscapes $m]"
           } 
       } else {
           InsertLog "OpenFile failed: Code= $errorCode; Info= [first [split $errorInfo \n]]"
       }
   }

   proc do_closefile {} {
       variable DebugFlag
       global errorCode errorInfo
       global ErrorStatus
       variable ID
       variable RunNum

       set z [catch {::namespace inscope ::urn:TapeServer CloseFile $ID} msg]
# puts stdout "CloseFile $ID: $msg"
       set m [lindex $msg 5]
       if {$z == 0} {
           if {[first $m] == 0} {
              if {$DebugFlag} {InsertLog "CloseFile returned: [tail $m]"}

              do_inquireacqstatus
              incr RunNum
              do_setrunnumber

           } else {
             if {[info exists ErrorStatus([first $m])]} \
                 {set msg $ErrorStatus([first $m])} else {set msg "Error [first $m]"}
              InsertLog "$msg\n CloseFile returned:- \n[::htmlparse::mapEscapes $m]"
           } 
       } else {
           InsertLog "CloseFile failed: Code= $errorCode; Info= [first [split $errorInfo \n]]"
       }
   }

  proc do_inquireserverstate {} {
       variable DebugFlag
       global errorCode errorInfo
       global ErrorStatus
       variable TapeServerState
       variable Storage

       set z [catch {::namespace inscope ::urn:TapeServer InquireTapeServerState} msg]
# puts stdout "InquireTapeServerState: $msg"
       set m [lindex $msg 5]
       if {$z == 0} {
           if {[first $m] == 0} {
              if {$DebugFlag} {InsertLog "InquireTapeServerState returned: [tail $m]"}
              set TapeServerState [expr [tail $m] - 1]
              if {$TapeServerState == 0} {return}
              if {$TapeServerState == 1} {set Storage 0} else {set Storage 1; set TapeServerState 1}
           } else {
             if {[info exists ErrorStatus([first $m])]} \
                 {set msg $ErrorStatus([first $m])} else {set msg "Error [first $m]"}
              InsertLog "$msg\n InquireTapeServerState returned:- \n[::htmlparse::mapEscapes $m]"
           } 
       } else {
           InsertLog "InquireTapeServerState failed: Code= $errorCode; Info= [first [split $errorInfo \n]]"
       }
   }

  proc do_setserverstate {} {
       variable DebugFlag
       global errorCode errorInfo
       global ErrorStatus
       variable TapeServerState
       variable Storage

        if {$TapeServerState == 0} {
          set state 1
        } else {
          set state [expr $TapeServerState + $Storage + 1]
        }

       set z [catch {::namespace inscope ::urn:TapeServer SetTapeServerState $state} msg]
# puts stdout "SetTapeServerState $state: $msg"
       set m [lindex $msg 5]
       if {$z == 0} {
           if {[first $m] == 0} {
              if {$DebugFlag} {InsertLog "SetTapeServerState returned: [tail $m]"}
           } else {
             if {[info exists ErrorStatus([first $m])]} \
                 {set msg $ErrorStatus([first $m])} else {set msg "Error [first $m]"}
              InsertLog "$msg\n SetTapeServerState returned:- \n[::htmlparse::mapEscapes $m]"
           } 
       } else {
           InsertLog "SetTapeServerState failed: Code= $errorCode; Info= [first [split $errorInfo \n]]"
       }
   }

  proc do_setrunnumber {} {
       variable DebugFlag
       global errorCode errorInfo
       global ErrorStatus
       variable RunNum

       set z [catch {::namespace inscope ::urn:TapeServer SetRunNumber $RunNum} msg]
# puts stdout "SetRunNumber $RunNum: $msg"
       set m [lindex $msg 5]
       if {$z == 0} {
           if {[first $m] == 0} {
              if {$DebugFlag} {InsertLog "SetRunNumber returned: [tail $m]"}
           } else {
             if {[info exists ErrorStatus([first $m])]} \
                 {set msg $ErrorStatus([first $m])} else {set msg "Error [first $m]"}
              InsertLog "$msg\n SetRunNumber returned:- \n[::htmlparse::mapEscapes $m]"
           } 
       } else {
           InsertLog "SetRunNumber failed: Code= $errorCode; Info= [first [split $errorInfo \n]]"
       }
   }

  proc do_inquireacqstatus {} {
       variable DebugFlag
       global errorCode errorInfo
       global ErrorStatus
       variable AcqInfo
       variable RunNum 

       set z [catch {::namespace inscope ::urn:TapeServer InquireAcqStatus} msg]
# puts stdout "InquireAcqStatus: $msg"
       set m [lindex $msg 5]
       if {$z == 0} {
           if {[first $m] == 0} {
              if {$DebugFlag} {InsertLog "InquireAcqStatus returned: [tail $m]"}
              set AcqInfo [tail $m]
              set RunNum [lindex $AcqInfo 4]
           } else {
             if {[info exists ErrorStatus([first $m])]} \
                 {set msg $ErrorStatus([first $m])} else {set msg "Error [first $m]"}
              InsertLog "$msg\n InquireAcqStatus returned:- \n[::htmlparse::mapEscapes $m]"
           } 
       } else {
           InsertLog "InquireAcqStatus failed: Code= $errorCode; Info= [first [split $errorInfo \n]]"
       }
   }

   proc do_update {} {
      variable StreamState
      variable BlocksWritten 
      variable KbytesWritten 
      variable DataRate 
      variable DataPercent
      variable TapeServerState
      variable Properties
      variable DevStatus

        do_inquiredevices
        do_inquiredevicestatus
        do_inquirestreamstatus

        do_inquirestreamstate 1
        set BlocksWritten [lindex $StreamState 1]
        set KbytesWritten [lindex $StreamState 2]
        set DataRate [lindex $StreamState 3]   

        do_inquireacqstatus     

        do_inquireserverstate

        set Properties(DEVICES) ""

        if {$TapeServerState != 0} { 

           set Properties(ALLOCATE) "DISABLED"
           set Properties(DEALLOCATE) "DISABLED"
           set Properties(INITIALISE) "DISABLED"
           set Properties(IDENTIFY) "DISABLED"
           set Properties(MOUNT) "DISABLED"
           set Properties(DISMOUNT) "DISABLED"
           set Properties(VOLN) "READONLY"
           set Properties(FILEN) "READONLY"
           set Properties(OPEN) "DISABLED"
           set Properties(CLOSE) "DISABLED"
           set Properties(RUN) "DISABLED"
        } else {

            switch -glob $DevStatus {

               *ing  {
                   set Properties(ALLOCATE) "DISABLED"
                   set Properties(DEALLOCATE) "DISABLED"
                   set Properties(INITIALISE) "DISABLED"
                   set Properties(IDENTIFY) "DISABLED"
                   set Properties(MOUNT) "DISABLED"
                   set Properties(DISMOUNT) "DISABLED"
                   set Properties(VOLN) "READONLY"
                   set Properties(FILEN) "READONLY"
                   set Properties(OPEN) "DISABLED"
                   set Properties(CLOSE) "DISABLED"
                   set Properties(RUN) "DISABLED"
               }

               unallocated  {
                   set Properties(ALLOCATE) ""
                   set Properties(DEALLOCATE) "DISABLED"
                   set Properties(INITIALISE) "DISABLED"
                   set Properties(IDENTIFY) "DISABLED"
                   set Properties(MOUNT) "DISABLED"
                   set Properties(DISMOUNT) "DISABLED"
                   set Properties(VOLN) ""
                   set Properties(FILEN) "READONLY"
                   set Properties(OPEN) "DISABLED"
                   set Properties(CLOSE) "DISABLED"
                   set Properties(RUN) "DISABLED"
               }

               allocated  {
                   set Properties(ALLOCATE) "DISABLED"
                   set Properties(DEALLOCATE) ""
                   set Properties(INITIALISE) ""
                   set Properties(IDENTIFY) ""
                   set Properties(MOUNT) ""
                   set Properties(DISMOUNT) "DISABLED"
                   set Properties(VOLN) ""
                   set Properties(FILEN) "READONLY"
                   set Properties(OPEN) "DISABLED"
                   set Properties(CLOSE) "DISABLED"
                   set Properties(RUN) "DISABLED"
               }

               mounted {
                   set Properties(ALLOCATE) "DISABLED"
                   set Properties(DEALLOCATE) "DISABLED"
                   set Properties(INITIALISE) "DISABLED"
                   set Properties(IDENTIFY) "DISABLED"
                   set Properties(MOUNT) "DISABLED"
                   set Properties(DISMOUNT) ""
                   set Properties(VOLN) ""
                   set Properties(FILEN) "READONLY"
                   set Properties(OPEN) ""
                   set Properties(CLOSE) "DISABLED"
                   set Properties(RUN) ""
               }

               open {
                   set Properties(ALLOCATE) "DISABLED"
                   set Properties(DEALLOCATE) "DISABLED"
                   set Properties(INITIALISE) "DISABLED"
                   set Properties(IDENTIFY) "DISABLED"
                   set Properties(MOUNT) "DISABLED"
                   set Properties(DISMOUNT) "DISABLED"
                   set Properties(VOLN) "READONLY"
                   set Properties(FILEN) "READONLY"
                   set Properties(OPEN) "DISABLED"
                   set Properties(CLOSE) ""
                   set Properties(RUN) "DISABLED"     
               }

               default {
                   set Properties(DEVICES) ""
                   set Properties(ALLOCATE) ""
                   set Properties(DEALLOCATE) ""
                   set Properties(INITIALISE) ""
                   set Properties(IDENTIFY) ""
                   set Properties(MOUNT) ""
                   set Properties(DISMOUNT) ""
                   set Properties(VOLN) ""
                   set Properties(FILEN) "READONLY"
                   set Properties(OPEN) ""
                   set Properties(CLOSE) ""
                   set Properties(RUN) ""
               }
            }
       }
  }


   proc do_click {} {
       variable cgidata
       variable started
       variable LogFlag
       variable ShowLogFlag
       variable JS
       variable VolN
       variable FileN
       variable RunName
       variable RunNum
       variable TapeServerState
       variable Storage

       set cgidata [ncgi::nvlist]

       if {$LogFlag == 1} {InsertLog "cgidata= ([llength $cgidata]) $cgidata"}

       if {[llength $cgidata] == 0} then {return}

       if {[llength $cgidata] < 2} then {
           InsertLog "CGI data is too short: $cgidata"
       } else {
           if {[lindex $cgidata 0] != "Widget"} then {
               InsertLog "Invalid CGI data: $cgidata"
           } else {
               set w [lindex $cgidata 1]

               switch -glob [lindex $w 0] {

                   RESET    {set started 0}
                   CLEAR    {EmptyLog}
                   ELOG     {PrintLog}
                   RELOAD   {do_update}
                   VARIABLES {show_variables}

            VERBOSE  {set Verbose [expr ($Verbose + 1) & 1]}

            INQUIREDEVICES    {do_inquiredevices}
            CLAIM             {do_claim}
            FREE              {do_free}
            ALLOCATE          {do_allocatedevice}
            DEALLOCATE        {do_deallocatedevice}
            INITIALISE        {do_initialisevolume}
            IDENTIFY          {do_identifyvolume}
            MOUNT             {do_mountvolume}
            DISMOUNT          {do_dismountvolume}
            OPEN              {do_openfile}
            CLOSE             {do_closefile}

            DEVNAMES        {select_devicename [lindex $w 1]}

            VOLN        {set VolN [lindex $w 1]}
            FILEN       {set FileN [lindex $w 1]}
            RUNNAME     {set RunName [lindex $w 1]}
            RUNNUM      {set RunNum [lindex $w 1]; do_setrunnumber}
            RUNINC      {set RunNum [expr $RunNum + [lindex $w 1]]; do_setrunnumber}

            SERVERSTATE    {set TapeServerState [lindex $w 1]; do_setserverstate}
            STORAGE        {
                if {[lindex $w 1] == "true"} {set Storage 1} else {set Storage 0}
                do_setserverstate
            }

                   HIDE     {set ShowLogFlag 0}
                   SHOW     {set ShowLogFlag 1}
                   LOGON    {set LogFlag 1}
                   LOGOFF   {set LogFlag 0}

                   MainLog {}
                   undefined {}
                   default {InsertLog "unexpected CGI data: [lindex $w 0]: $cgidata"}
               }
           }
       }
       do_update
    }

}   ;# end of if {$started == 0}



